; GIMP - The GNU Image Manipulation Program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;
;
;
; Script can be found under Filters > Artistic > GIMPressionist All Layers...


; Define the Function

(define (fp-script-fu-gimpressionist-all
   img      
            drawable
		actLayer)
(let* 	(
	(copyLayer 0)
	(preset "")
	(linked 0)
	(visible 0)
	)

(gimp-context-push)
(gimp-image-undo-group-start img)



(if (<> actLayer 1)
	(begin
	(set! copyLayer (car (gimp-layer-copy drawable TRUE)))
	(gimp-image-insert-layer img copyLayer 0 -1)
	(plug-in-gimpressionist RUN-INTERACTIVE img copyLayer preset)
	(gimp-image-remove-layer img copyLayer)
	(if (= actLayer 0)
	(map (lambda (x) (plug-in-gimpressionist RUN-NONINTERACTIVE img x preset)) (vector->list (cadr (gimp-image-get-layers img))))
	)
)
)

(if (= actLayer 1)
	(plug-in-gimpressionist RUN-INTERACTIVE img drawable preset)
)


(if (= actLayer 2)

(begin
		(set! visible (let loop ((layers (vector->list (cadr (gimp-image-get-layers img))))
                           (visible '()) )
                  (if (null? layers)
                    (reverse visible)
                    (loop (cdr layers)
                          (if (zero? (car (gimp-item-get-visible (car layers)))) visible  (cons (car layers) 						visible) )))))
			
			(map (lambda (x) (plug-in-gimpressionist RUN-WITH-LAST-VALS img x preset)) visible)
	)
)

(if (= actLayer 3)


	(begin
		(set! linked (let loop ((layers (vector->list (cadr (gimp-image-get-layers img))))
                           (linked '()) )
                  (if (null? layers)
                    (reverse linked)
                    (loop (cdr layers)
                          (if (zero? (car (gimp-item-get-linked (car layers)))) linked  (cons (car layers) 						linked) )))))
			
			(map (lambda (x) (plug-in-gimpressionist RUN-WITH-LAST-VALS img x preset)) linked)
	)
)




(gimp-image-undo-group-end img)

(gimp-context-pop)

(gimp-displays-flush)

)
)

(script-fu-register "fp-script-fu-gimpressionist-all"
  "<Image>/Filters/Artistic/GIMPressionist All Layers..."
  "Run the GIMPressionist plugin on chosen layers."
  "Art Wade"
  "Art Wade"
  "January 20, 2014"
  "RGB* GRAY*"
  SF-IMAGE          "Image" 0
  SF-DRAWABLE       "Drawable" 0
  SF-OPTION	    "Layers to work on" 		'("All"
							"Active"
							"Visible"
							"Linked")
)

